import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class BINDC_to_bus extends Frame implements ItemListener,ActionListener
 { 
    private Choice components,buses;
    private TextField max_ports,ports_chosen;
    private TextField select_port;
    private RandomAccessFile ip_file,load_ips,bus_file,load_buses;
    private String ip_name_string,bus_name_string,selected,to_be_deleted;
    private ip_record ip_record;
    private bus_record b_record;
    private processor_record p_record;
    private RandomAccessFile load_processors,processor_file;
    private Label  records;
    private File lip,ipf,lb,bf,lp,pf;
    private int count1,position1,count2,position2,l;
    private Label l0,l1,l2,l3;
    private Button Bind,Close;
    private Ctob_binding_class ctob_object;
    private Ctob_binding_List ctob_list;
    private Ctob_binding_Node fnode;
    private String total,processor_name_string;
    private double[] bus_bwidths;
    private double hspio_bwidth,hbdma_bwidth;
 
   public BINDC_to_bus(Ctob_binding_List ctob_list)
   {
     super ("Bind an existing Component to a Bus.");
     this.ctob_list = ctob_list;
     bus_bwidths = new double[5];
     ip_record = new ip_record();
     b_record = new bus_record();
     p_record = new processor_record();
     components = new Choice();
     buses = new Choice();
     max_ports = new TextField(5);
     select_port= new TextField(5);
     ports_chosen = new TextField(5);
     ports_chosen.setEditable(false);
     setLayout(new  GridLayout(6,2,10,15));
     records = new Label("Choose an IP/IO Component :");
     l0 = new Label("The Max Number of ports in the selected Component:");
     l3 = new Label("Already chosen ports for this component");
     l1 = new Label ("The port Selected:");
     l2 = new Label("The selected Bus:");
     Bind = new Button("Bind");
     Close = new Button("Close");
     setBackground(Color.lightGray);
     setForeground(Color.black);
     Font f = new Font("Serif",Font.PLAIN+Font.BOLD,15);
     setFont(f);
     lip = new File("load_ips");
     ipf = new File("ip_file");
   
   if(lip.exists())  /* If this does not exist, we can't load anything */
   {
     try
        {
            if(ipf.exists()&&(ipf.length()!=0))
            {
               ip_file = new RandomAccessFile("ip_file","rw");
            }
            else
            {
              ip_file = new RandomAccessFile("ip_file","rw");
              count1=0;
              position1 = -1;
            }
            load_ips = new RandomAccessFile("load_ips","rw");
            count1 = load_ips.readInt();   
            position1 = load_ips.readInt();
        }                                                                     
                   
     catch(IOException e)
        {
              System.err.println("From BINDC, File could not be opened ");
              setVisible(false);
        }
              
     for(int k=count1;k<=position1;k++)
        {
          try
          {
             ip_file.seek( (long) k*(ip_class.object_size));
             ip_record.read(ip_file); 
             ip_name_string  = ip_record.getIdentifier();
             if(ip_name_string.startsWith("Deleted"))
             continue;
             components.add(ip_name_string.trim());
          }
          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }
       }   
    }/* end of if */
    
   components.addItemListener(this);
   Bind.addActionListener(this);
   Close.addActionListener(this);
   add(records);
   add(components);
   add(l0);
   add(max_ports);
   add(l3);
   add(ports_chosen);
   add(l1);
   add(select_port);
   add(l2);

   DelCIP_MyWindowAdapter adapter = new DelCIP_MyWindowAdapter(this);
   addWindowListener(adapter);

   
   /* Select available buses into the Choce box "buses".
    */

   lb = new File("load_buses");
   bf = new File("bus_file");
   if(lb.exists())  /* If this does not exist, we can't load anything */
   {
     try
      {
            if(bf.exists()&&(bf.length()!=0))
            {
               bus_file = new RandomAccessFile("bus_file","rw");
            }
            else
            {
              bus_file = new RandomAccessFile("bus_file","rw");
              count2=0;
              position2 = -1;
            }
       }
     catch(IOException e)
         {
              System.err.println("From BINDC, File could not be opened. ");
              setVisible(false);
         }
     try
      {
            load_buses = new RandomAccessFile("load_buses","rw");
            count2 = load_buses.readInt();   
            position2= load_buses.readInt();
      }
                   
     catch(IOException e)
         {
              System.err.println("load_buses File could not be opened. ");
              setVisible(false);
         }
         l=0;     
     for(int k=count2;k<=position2;k++)
        {
          
          try
          {
             bus_file.seek( (long) k*(bus_class.object_size));
             b_record.read(bus_file); 
             bus_name_string  = b_record.getIdentifier();
             if(bus_name_string.startsWith("Deleted"))
             continue;

         /* If the bus is either HS PIO or HB DMA, store their bandwidths for future use. We store this 
          * bandwidth to include in the ctob_list.
          */

             if(bus_name_string.startsWith("HS PIO"))
             {
               hspio_bwidth= b_record.getBwidth();
             }
             if(bus_name_string.startsWith("HB DMA"))
             {
               hbdma_bwidth= b_record.getBwidth();
             }
             buses.add(bus_name_string.trim());
             bus_bwidths[l++]=b_record.getBwidth();
          }
          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }
       }   
    }/* end of if */
                   

   /* As  MIPS, TM are by default connected to HS PIO and HB DMA busses respectively,
    *  add their binding information to this list automatically.
    */                 

   lp = new File("load_processors");
   pf = new File("processor_file");
   if(lp.exists())  /* If this does not exist, we can't load anything. */
   {
     try
      {
            if(pf.exists()&&(pf.length()!=0))
            {
               processor_file = new RandomAccessFile("processor_file","rw");
            }
            else
            {
              processor_file = new RandomAccessFile("processor_file","rw");
              count2=0;
              position2 = -1;
            }
       }
     catch(IOException e)
         {
              System.err.println("From BINDT, File could not be opened. ");
              setVisible(false);
         }
     try
      {
            load_processors = new RandomAccessFile("load_processors","rw");
            count2 = load_processors.readInt();
            position2= load_processors.readInt();
      }

     catch(IOException e)
         {
              System.err.println("load_processors File could not be opened. ");
              setVisible(false);
         }

     for(int k=count2;k<=position2;k++)
        {

          try
          {
             processor_file.seek( (long) k*(processor_class.object_size));
             p_record.read(processor_file);
             processor_name_string  = p_record.getIdentifier();
             if(processor_name_string.startsWith("Deleted"))
             continue;
             if(processor_name_string.startsWith("MIPS"))
             {
               ctob_object = new Ctob_binding_class();
               ctob_object.ip_identifier = processor_name_string.trim();
               ctob_object.port = 0; /* By default processor is connected to bus thru port 0 */
               ctob_object.bus_identifier = "HS PIO";
               ctob_object.Bwidth=hspio_bwidth;
               ctob_list.insertAtBack(ctob_object);
             }
             if(processor_name_string.startsWith("Pentium"))
             {
               ctob_object = new Ctob_binding_class();
               ctob_object.ip_identifier = processor_name_string.trim();
               ctob_object.port = 0; /* By default processor is connected to bus thru port 0 */
               ctob_object.bus_identifier = "HS PIO";
               ctob_object.Bwidth=hspio_bwidth;
               ctob_list.insertAtBack(ctob_object);
             }
             if(processor_name_string.startsWith("Sun"))
             {
               ctob_object = new Ctob_binding_class();
               ctob_object.ip_identifier = processor_name_string.trim();
               ctob_object.port = 0; /* By default processor is connected to bus thru port 0 */
               ctob_object.bus_identifier = "HB DMA";
               ctob_object.Bwidth=hbdma_bwidth;
               ctob_list.insertAtBack(ctob_object);
             }
         }
          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }
       }
    } /* end of if */


   buses.addItemListener(this);
  // close("load_processors");
  // close("load_busses");
   add(buses);
   add(Bind);
   add(Close);
}           

 public void itemStateChanged(ItemEvent e)
   {
     if(e.getSource()==components)
     {
         selected  = new String(components.getSelectedItem().trim());

       /* Display the max number of ports available
        * for this selected component.
        */
      total = "";
      try
      { 
       for(int k=count1; k<=position1;k++)
        {
          ip_file.seek((long) k*(ip_class.object_size));
          ip_record.read(ip_file);
          if(selected.equals(ip_record.getIdentifier().trim()))
           {
             max_ports.setText(String.valueOf(ip_record.getPorts()));
             fnode = ctob_list.firstNode;
             while(fnode != null)
             {
               if(selected.equals(fnode.getCNode_data().ip_identifier))
               {
                total = total + " "+String.valueOf(fnode.getCNode_data().port);
               }
               fnode=fnode.next_node;
             }
             ports_chosen.setText(total);
             break;                                                     
           }

        }
      }
      catch (IOException ioe)
      {
        System.err.println("2:from ftom  File not opened properly\n");
        System.exit(1);
      }

     }
     else
     {
       String to_be_deleted  = buses.getSelectedItem();
     }        
   }
   public void actionPerformed(ActionEvent ae)
   {
     String arg = ae.getActionCommand();
       if(arg.equals("Bind"))
       {
          ctob_object = new Ctob_binding_class();
          ctob_object.ip_identifier = components.getSelectedItem().trim();
          ctob_object.port = Integer.parseInt(select_port.getText().trim());
          ctob_object.bus_identifier = buses.getSelectedItem().trim();
          ctob_object.Bwidth=bus_bwidths[buses.getSelectedIndex()];
          ctob_list.insertAtBack(ctob_object);

          total = total + " "+String.valueOf(ctob_object.port);
          ports_chosen.setText(total);

       }
       else if (arg.equals("Close"))
       {
          setVisible(false);
       }
   }
}
