import java.awt.*;
import java.awt.event.*;
import java.io.*;

/* This file binds the high level tasks to components(IPs and processors). For this purpose the main linked
 * list, Module_List is taken as input parameter. This binding information is added to the main list as shown in
 * the report linked list diagram (Please see the diagram in the report to understand well).
 */

public class BINDT_to_C extends Frame implements ItemListener,ActionListener
 { 
    private Choice components,tasks;
    private RandomAccessFile ip_file,load_ips,processor_file,load_processors;
    private String ip_name_string,processor_name_string,selected,to_be_deleted;
    private ip_record ip_record;
    private processor_record p_record;
    private Label  l0,l1,l2;
    private File lip,ipf,lp,pf;
    private int count1,position1,count2,position2,i;
    private Button Bind,Close;
    protected TtoC_binding_class ttoc_object;
    private TtoC_binding_Node ttob;
    private String total,selected_component,selected_task;
    private Module_List m_list;
    private Module_Node fnode;
    private module_ip_processor tonc;
    private boolean ips;
    private Button ITC_bind;
    private BINDITC_to_C ctop;
    private int[] channels,ports;
  
 
   public BINDT_to_C( Module_List m_list)
   {

/* The follwoing creates the necessary buttons and choice boxes */

     super ("Bind an existing Task to a Component.");
     this.m_list = m_list;
     ip_record = new ip_record();
     channels = new int[10];
     ports = new int[10];
      
     p_record = new processor_record();
     components = new Choice();
     tasks = new Choice();
     setLayout(new  GridLayout(6,2,10,15));
     l0 = new Label("Choose a Task :");
     l1= new Label("Choose a component");
     l2 = new Label("Bind its ITC");

     
     Bind = new Button("Bind");
     Close = new Button("Close");
     ITC_bind = new Button("Bind its channels to ports");
     setBackground(Color.lightGray);
     setForeground(Color.black);
     Font f = new Font("Serif",Font.PLAIN+Font.BOLD,15);
     setFont(f);

   /* Select available IPs into the Choice box "components".
    */
     
   /* load_ips file stores the necessary information such as how many processors are existing in the file
    * "ip_file" to load them etc. So, if this does not exist, we don't have any info about the library of IPs,
    * even though the library file may exist. In that case we ignore the library and tell that no IPs to load.
    */ 

     lip = new File("load_ips");
     ipf = new File("ip_file");

   if(lip.exists())  /* If this does not exist, we can't load anything*/ 
   {
     try
        {
            if(ipf.exists()&&(ipf.length()!=0))
            {
               ip_file = new RandomAccessFile("ip_file","rw");
            }
            else
            {
              ip_file = new RandomAccessFile("ip_file","rw");
              count1=0;
              position1 = -1;
            }
            load_ips = new RandomAccessFile("load_ips","rw");
            count1 = load_ips.readInt();   
            position1 = load_ips.readInt();
        }                                                                     
                   
     catch(IOException e)
        {
              System.err.println("From BINDC, File could not be opened ");
              setVisible(false);
        }
              
     for(int k=count1;k<=position1;k++)
        {
          try
          {
             ip_file.seek( (long) k*(ip_class.object_size));
             ip_record.read(ip_file); 
             ip_name_string  = ip_record.getIdentifier();
             if(ip_name_string.startsWith("Deleted")) /* Ignore the IPs that are marked "Deleted" */
             continue;
             components.add(ip_name_string.trim()); /* Else add them to the choice box to be selected and bound */
          }
          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }
       }   
    }/* end of if */
    else
     count1 = +1;     /* That means no IPs , so  to avoid the loop in itemStateChanged.*/ 
    
   components.addItemListener(this);
   tasks.addItemListener(this);
   ITC_bind.addActionListener(this);
   Bind.addActionListener(this);
   Close.addActionListener(this);
   add(l0);
   add(tasks);
   add(l1);
   add(components);
   add(l2);
   add(ITC_bind);
   add(Bind);     
   add(Close);
   

   DelCIP_MyWindowAdapter adapter = new DelCIP_MyWindowAdapter(this);
   addWindowListener(adapter);

   
   /* Select available processors into the Choice box "components".
    * The comment here is similar to the above. The file load_processors stores info about the
    * library of processors in the file "processors_file". 
    */

   lp = new File("load_processors");
   pf = new File("processor_file");
   if(lp.exists())  /* If this does not exist, we can't load anything. */ 
   {
     try
      {
            if(pf.exists()&&(pf.length()!=0))
            {
               processor_file = new RandomAccessFile("processor_file","rw");
            }
            else
            {
              processor_file = new RandomAccessFile("processor_file","rw");
              count2=0;
              position2 = -1;
            }
       }
     catch(IOException e)
         {
              System.err.println("From BINDT, File could not be opened. ");
              setVisible(false);
         }
     try
      {
            load_processors = new RandomAccessFile("load_processors","rw");
            count2 = load_processors.readInt();   
            position2= load_processors.readInt();
      }
                   
     catch(IOException e)
         {
              System.err.println("load_processors File could not be opened. ");
              setVisible(false);
         }
              
     for(int k=count2;k<=position2;k++)
        {
          
          try
          {
             processor_file.seek( (long) k*(processor_class.object_size));
             p_record.read(processor_file); 
             processor_name_string  = p_record.getIdentifier();
             if(processor_name_string.startsWith("Deleted")) /* Ignore the processors marked "Deleted" */
             continue;
             components.add(processor_name_string.trim()); /* Else add to the choice box */
          }
          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }
       }   
    } /* end of if */

   /* Select available tasks into the Choice box "tasks".
    */
    fnode = m_list.firstNode; /* Remember,task info is in this linked list. */
    while(fnode != null)
    {
       tasks.add(fnode.getMNode_data());
       fnode = fnode.next_module;
    } 
    
                        
}           

 public void itemStateChanged(ItemEvent e)
   {
     if(e.getSource()==components)
     {
         selected_component  = new String(components.getSelectedItem().trim());
      ips=false;
      try
      { 
       for(int k=count1; k<=position1;k++)
        {
          ip_file.seek((long) k*(ip_class.object_size));
          ip_record.read(ip_file);
          if(selected_component.equals(ip_record.getIdentifier().trim()))
           {
             ips = true;
             ttoc_object = new TtoC_binding_class();

  /* As IPs have no stack or data size etc, fill them to be zeros */
             ttoc_object.s_size=0;
             ttoc_object.d_size=0;
             ttoc_object.c_size=0;
             ttoc_object.d_inst=0;
             ttoc_object.l_inst=0;
             ttoc_object.s_inst=0;
             break;                                                   
           }
        }

        if(ips==false)
         {

           /* That means it is a processor, which have data size etc to be filled . 
            *  pop the form for task-on-IP/TM/MIPS Characteristics. 
            */

             System.gc();
             ttoc_object = new TtoC_binding_class();
             tonc = new module_ip_processor("Processor",ttoc_object);
             tonc.setVisible(true);
             tonc.setSize(600,400);
                                                        
         }  
          
      }
      catch (IOException ioe)
      {
        System.err.println("2:from ftom  File not opened properly\n");
        System.exit(1);
      }

     }
     else if(e.getSource()==tasks)/* Task is chosen */
     {
      selected_task = new String(tasks.getSelectedItem().trim());
     }
 }                          
   public void actionPerformed(ActionEvent ae)
   {
     String arg = ae.getActionCommand();

       if(ae.getSource()== ITC_bind) /* Float the  Bind the ITC channels frame. */
        {
         
           /* Folat the channel to port Frame and get the binding info of channels to ports and componets */

           ctop = new BINDITC_to_C(m_list,ttoc_object,selected_task,selected_component,channels,ports);
           ctop.setVisible(true);
           ctop.setSize(600,500);
        }   
       if(arg.equals("Bind")) /* Finally add the ttoc_object node to the linked list */
       {

          ttoc_object.component = components.getSelectedItem().trim();
          ttoc_object.task = tasks.getSelectedItem().trim();
          ttoc_object.channels[0]=channels[0];
          ttoc_object.ports[0]=ports[0];  /* They have max channels and max ports respectively of this task and component */
          for(i=1;i<=(channels[0]>ports[0]?channels[0]:ports[0]);i++)
          {
           
           ttoc_object.channels[i] = channels[i];
           ttoc_object.ports[i] = ports[i];
          }
           m_list.insert_Binding(ttoc_object);
       }                    
       else if (arg.equals("Close"))
       {
          setVisible(false);
       }
   }
}
