/* This is similar to ModCP_form, except that  it makes the fields uneditable, simply removes the partcular 
 * processor  from the library and from RAM paramanently. Remember that in the case of components, if u remove 
 * a component, it gets removed from the library also. Similar is the case with DelC*_form files.
 * It is important to note that these files make use of another file like file_to_*_form in carrying out the
 * above functionality. 
 */


import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class DelCP_form extends Frame implements ItemListener
 { 
    private Choice components;
    private RandomAccessFile processor_file,load_processors;
    private String processor_name_string;
    private processor_record p_record;
    private file_to_processor_form ftop;
    private Label  records;
    private File lp,pf;
    private int position,count;
 
   public DelCP_form(String title)
   {
     super ("Available " + title +  " Components for deletion");
     p_record = new processor_record();
     components = new Choice();
     setLayout(new  FlowLayout());
     records = new Label("The Existing Processor Components are :");
     setBackground(Color.lightGray);
     setForeground(Color.black);
     Font f = new Font("Serif",Font.PLAIN+Font.BOLD,15);
     setFont(f);
     lp = new File("load_processors");
     pf = new File("processor_file");
   if(lp.exists())  /* If this does not exist, we can't load anything */
   {
     try
           {
            if(pf.exists()&&(pf.length()!=0))
            {
               processor_file = new RandomAccessFile("processor_file","rw");
            }
            else
            {
              processor_file = new RandomAccessFile("processor_file","rw");
              count=0;
              position = -1;
            }
            load_processors = new RandomAccessFile("load_processors","rw");
            count = load_processors.readInt();   
            position = load_processors.readInt();
           }
                   
     catch(IOException e)
         {
              System.err.println("From Del_C, File could not be opened ");
              setVisible(false);
         }
                      
        for(int k=count;k<=position;k++)
        {
          try
          {
             processor_file.seek( (long) k*(processor_class.object_size));
             p_record.read(processor_file); 
             processor_name_string  = p_record.getIdentifier();
             if(processor_name_string.startsWith("Delet"))
             continue;
             components.add(processor_name_string.trim());
          }
          catch(IOException e)
          {
              System.err.println("From DelCP File could not be read ");
              System.exit(1);
          }
       }
   }  
   components.addItemListener(this);
   add(records);
   add(components);
   DelCP_MyWindowAdapter adapter = new DelCP_MyWindowAdapter(this);
   addWindowListener(adapter);
  }

 public void itemStateChanged(ItemEvent e)
   {
      String to_be_deleted  = (components.getSelectedItem()).trim();
      ftop = new file_to_processor_form ("Delete Processor Item",to_be_deleted,processor_file,count,position);
      ftop.setVisible(true);
      ftop.setSize(900,800);
      setVisible(false);
   }
}
