    import java.awt.*;
    import java.awt.event.*;
    import java.io.*;
    
 public class MenuFrame extends Frame implements ActionListener
 {
      Frame pf_mips;
      Frame pf_tm;
      Frame mf;
      Frame busf,mbf,mdf,pf_pt,pf_su;
      Frame mlf;
      RandomAccessFile memory_file;
      RandomAccessFile bus_file;
      private Module_List m_list;
      private Ctob_binding_List ctob_list;
      
     
        
    MenuFrame (String title)
      {
        super(title);
        MenuBar mbar = new MenuBar();
        setMenuBar(mbar);
                  
 /* Start the Module Linked List, which stores the information about tasks and component to bus binding list
  * which stores the binding information of a particular component with a particular bus. Here, we just 
  * initialize the list. 
  */
       m_list = new Module_List();
       ctob_list = new Ctob_binding_List();

 /* APPLICATION MENU */

        Menu Application = new Menu("Application");
        MenuItem item0,item1,item2,item3,ck1,ck2,ck3,save1;
        Font f = new Font("Sans Serif", Font.PLAIN,12);
        setFont(f);	
        setBackground(new Color(200,150,200));
        Application.add(item0 = new MenuItem("Load"));
        Application.add(item1 = new MenuItem("Add Module.."));
        Application.add(item2 = new MenuItem("Delete Module.."));
        Application.add(item3 = new MenuItem("Modify Module.."));
        Application.add(save1 = new MenuItem("Save..."));
        Application.add(ck1 = new MenuItem("Check"));
        mbar.add(Application);
        item0.addActionListener(this);
        item1.addActionListener(this);
        item2.addActionListener(this);
        item3.addActionListener(this);
        save1.addActionListener(this);

 /* ARCHITECTURE MENU */

        MenuItem LP,LM,LB,LI; /* Load Items on Menu */
        Menu Architecture = new Menu("Architecture");

   /* Load Sub Menu */

        Menu sub0 = new Menu("Load");
        sub0.add(LP= new MenuItem("PRocessor"));
        sub0.add(LM= new MenuItem("MEmory"));
        sub0.add(LB= new MenuItem("BUs"));
        sub0.add(LI= new MenuItem("IP/IO DEvice"));

   /*  Add Component Sub Menu */

        Menu sub = new Menu("Add Component...");
        Menu sub1 = new Menu("Processor");
        MenuItem item4,item5,item6,item7,item8,item9,item16,item17,item32,item33;
        sub1.add(item4 = new MenuItem("MIPS"));
        sub1.add(item16 = new MenuItem("TM"));
        sub1.add(item32 = new MenuItem("Sun Ultra"));
        sub1.add(item33 = new MenuItem("Pentium"));
        sub.add(sub1);
        sub.add(item5 = new MenuItem("Memory"));
        sub.add(item6 = new MenuItem("Bus"));
        sub.add(item7 = new MenuItem("IP/IO Device"));
        Architecture.add(sub0);
        Architecture.add(sub);

   /* Delete Component Sub Menu */

        MenuItem item18,item19,item20;
        Menu sub2 = new Menu("Delete Component...");
        sub2.add(item17 = new MenuItem("processor"));
        sub2.add(item18 = new MenuItem("memory"));
        sub2.add(item19 = new MenuItem("bus"));
        sub2.add(item20 = new MenuItem("IP/IO device"));
        Architecture.add(sub2);

   /* Modify Component Sub Menu */

        MenuItem item21,item22,item23,item24;
        Menu sub3 = new Menu("Modify Component...");
        sub3.add(item21 = new MenuItem("PROCESSOR"));
        sub3.add(item22 = new MenuItem("MEMORY"));
        sub3.add(item23 = new MenuItem("BUS"));
        sub3.add(item24 = new MenuItem("IP/IO DEVICE"));
        Architecture.add(sub3);
        Architecture.add(ck2 = new MenuItem("Check"));

        mbar.add(Architecture);

 /* Register for events */

        item4.addActionListener(this);
        item5.addActionListener(this);
        item6.addActionListener(this);
        item16.addActionListener(this);
        item32.addActionListener(this);
        item33.addActionListener(this);
        item18.addActionListener(this);
        item22.addActionListener(this);
        item19.addActionListener(this);
        item23.addActionListener(this);
        item17.addActionListener(this);
        item21.addActionListener(this);
        item7.addActionListener(this);
        item20.addActionListener(this);
        item24.addActionListener(this);
        LM.addActionListener(this);
        LP.addActionListener(this);
        LB.addActionListener(this);
        LI.addActionListener(this);
               
 /* BINDING MENU */
  
        Menu bind = new Menu("Bind");
        MenuItem item25,item26,item27;
        bind.add(item25 = new MenuItem("Task-To-Component"));
        bind.add(item26 = new MenuItem("Component-To-Bus"));
        bind.add(item27 = new MenuItem("Check"));
        mbar.add(bind);
        item25.addActionListener(this);
        item26.addActionListener(this);
         
        
/*  COMPUTE MENU   */

        Menu compute  = new Menu("Compute");
        MenuItem item10,item11,item12,item28;
        compute.add(item10 = new MenuItem("Processor Utilization..."));
        Menu sub_m = new Menu("Memory Utilization...");
        sub_m.add(item11 = new MenuItem("Space Utilization..."));
        sub_m.add(item28 = new MenuItem("Bandwidth Utilization..."));
        compute.add(sub_m);
        compute.add(item12 = new MenuItem("Bus Utilization..."));
        mbar.add(compute);
        item10.addActionListener(this);
        item11.addActionListener(this);
        item12.addActionListener(this);
        item28.addActionListener(this);


/*  VISUALIZATION MENU */

        Menu visualize   = new Menu("Visualize");
        MenuItem item13,item14,item15;
        visualize.add(item13 = new MenuItem("Visualize..."));
        visualize.add(item14 = new MenuItem("Memory  Utilization..."));
        visualize.add(item15 = new MenuItem("Bus Utilization..."));
        mbar.add(visualize);
        item13.addActionListener(this);
 
        MenuF_MyWindowAdapter adapter = new MenuF_MyWindowAdapter(this);
        addWindowListener(adapter);
  }

 public void actionPerformed(ActionEvent e)
     {
         String arg = (String) e.getActionCommand();

        if(arg.equals("MIPS"))
        {
         pf_mips = new processor_mipsform("Processor Form");
         pf_mips.setSize(600,450);
         pf_mips.setVisible(true);
        }
        if(arg.equals("TM"))
        {
         pf_tm = new processor_tmform("Processor Form");
         pf_tm.setSize(600,450);
         pf_tm.setVisible(true);
        }
        if(arg.equals("Sun Ultra"))
        {
         pf_su = new processor_sunform("Processor Form");
         pf_su.setSize(600,450);
         pf_su.setVisible(true);
        }
        if(arg.equals("Pentium"))
        {
         pf_pt = new processor_pentform("Processor Form");
         pf_pt.setSize(600,450);
         pf_pt.setVisible(true);
        }
        else if(arg.equals("Memory"))
        {
         mf = new memory_to_file_form("Memory Form");
         mf.setSize(700,450);
         mf.setVisible(true);
        }
        else if(arg.equals("Bus"))      /* Add Bus Component */
        {
          busf = new bus_to_file_form("Bus Form");
          busf.setSize(700,300);
          busf.setVisible(true);
        }
        else if(arg.equals("Add Module.."))
        {
         mlf = new module_form("Module  Form",m_list);
         mlf.setSize(716,445);
         mlf.setVisible(true);       
        }
        else if(arg.equals("Delete Module.."))
        {
         DM_form dml = new DM_form(m_list);
         dml.setSize(500,300);
         dml.setVisible(true);
        }
        else if(arg.equals("Modify Module.."))
        {
         MM_form mml = new MM_form(m_list);
         mml.setSize(500,300);
         mml.setVisible(true);
        }
        else if(arg.equals("Save...")) /* Save an existing module */
        {
         SM_form sml = new SM_form(m_list);
         sml.setSize(500,300);
         sml.setVisible(true);
        }
        else if(arg.equals("Load")) /* Load an existing module */
        {
         MLoad_form lmf = new MLoad_form(m_list);
         lmf.setSize(500,300);
         lmf.setVisible(true);
        }
                
        else if(arg.equals("memory"))
        {                                                               
         DelCM_form dcf = new DelCM_form("memory");
         dcf.setSize(716,445);
         dcf.setVisible(true);
        }
        else if(arg.equals("bus"))  /* Delete Bus Component */
         {
           DelCB_form dbf = new DelCB_form("bus");
           dbf.setSize(700,300);
           dbf.setVisible(true);
         }
        else if(arg.equals("processor"))  /* Delete Processor Component */
         {
           DelCP_form dpf = new DelCP_form("processor");
           dpf.setSize(700,300);
           dpf.setVisible(true);
         }

        else if(arg.equals("BUS"))  /* Modify  BUS component */
         {
           ModCB_form mbf = new ModCB_form("bus");
           mbf.setSize(700,300);
           mbf.setVisible(true);
         }
        else if(arg.equals("BUs"))   /* Load Bus Components */
        {
          new LB_Components();
        }
                  
        else if(arg.equals("IP/IO Device"))  /* Add  IP  component */
         {
           ip_to_file_form aiof = new ip_to_file_form("IP/IO device");
           aiof.setSize(700,300);
           aiof.setVisible(true);
         }

        else if(arg.equals("IP/IO DEVICE"))  /* Modify  IP component */
         {
           ModCIP_form miof = new ModCIP_form("IP/IO device");
           miof.setSize(700,300);
           miof.setVisible(true);
         }
        else if(arg.equals("IP/IO device"))  /* Delete  IP component */
         {
           DelCIP_form diof = new DelCIP_form("IP/IO device");
           diof.setSize(700,300);
           diof.setVisible(true);
         }
        else if(arg.equals("IP/IO DEvice"))   /* Load IP Components */
        {
          new LIP_Components();
        }
               
        else if(arg.equals("PROCESSOR"))  /* Modify  PROCESSOR component */
         {
           ModCP_form mpf = new ModCP_form("processor");
           mpf.setSize(700,300);
           mpf.setVisible(true);
         }
        else if(arg.equals("PRocessor"))   /* Load Memory Components */
        {
          new LP_Components();
        }
                  
        else if(arg.equals("MEMORY"))   /* Modify Memory Component */
        {
          ModCM_form dcf = new ModCM_form("memory");
          dcf.setSize(716,445);
          dcf.setVisible(true);
        }

        else if(arg.equals("MEmory"))   /* Load Memory Components */
        {
          new LM_Components();
        }
                 
        else if(arg.equals("Processor Utilization..."))
        {
          Processor_Util pu = new Processor_Util(m_list,ctob_list);
          pu.setSize(600,300);
          pu.setVisible(true);
        }
        else if(arg.equals("Space Utilization..."))
        {
          MemSpace_Util cs = new MemSpace_Util(m_list);
          cs.setSize(400,200);
          cs.setVisible(true);
        }       

        else if(arg.equals("Bandwidth Utilization..."))
        {
          MemBw_Util cs = new MemBw_Util(m_list);
          cs.setSize(400,200);
          cs.setVisible(true);
        }       
        else if(arg.equals("Bus Utilization..."))
        {
          BW_Util cs = new BW_Util(m_list,ctob_list);
          cs.setSize(400,200);
          cs.setVisible(true);
        }       

        else if(arg.equals("Component-To-Bus"))
        {
          BINDC_to_bus bctb = new BINDC_to_bus(ctob_list);
          bctb.setSize(900,500);
          bctb.setVisible(true);
        }
        else if(arg.equals("Task-To-Component"))
        {
          BINDT_to_C bctb = new BINDT_to_C(m_list);
          bctb.setSize(900,500);
          bctb.setVisible(true);
        }

        else if(arg.equals("Visualize..."))
        {
          visualize v =  new visualize(m_list,ctob_list);
          v.setSize(1000,700);
          v.setVisible(true);
        }

 }
}
