/* This creates the linked list containing the task information and its binding information with
 * the components. 
 */ 


public class Module_List
  {
      protected Module_Node firstNode;
      private Module_Node lastNode;
      protected module_class data;
      private Module_Node temp,prev;
      private TtoC_binding_Node tempb;
      private Task_Node temp1,prev1;
      private int counter;

      public Module_List()
      {
        firstNode = lastNode = null;
      }
/* Inssert next task node in the list */

      public synchronized void insertAtFront(module_class insertItem)
      {
        if(isEmpty())
         firstNode = lastNode = new Module_Node(insertItem);
        else
         firstNode = new Module_Node(insertItem, firstNode);
      }
      public synchronized void insertAtBack (module_class insertItem)
      {
        if(isEmpty())
          firstNode = lastNode = new Module_Node(insertItem);
        else
          lastNode = lastNode.next_module = new Module_Node(insertItem);
      }
/* Remove the specified task in the linked list */

      public synchronized void remove(String identifier)
      {
        temp = firstNode;
        if(identifier == firstNode.data.identifier)
           firstNode = firstNode.next_module;
        else
        {
          while(temp.data.identifier != identifier)
          {
            prev = temp;
            temp = temp.next_module;
          }

          /* Now temp points to the item to be removed. */

          if(temp==lastNode)
            lastNode = prev;
          prev.next_module = temp.next_module;
        }
    }

/* Insert the inter task communication of a particular task. Note that it adds the task node to the
 * last node in the list. (Please see the linked list diagram in the report. 
 */

  public synchronized void insertTaskList(Task_Node firstNode)
   {

      /* Search for the last node and add this task list to it */

        temp = this.firstNode;
        
        while(temp.next_module != null) /* Get the last node */
         temp = temp.next_module;
        temp.next_task = firstNode; /* firstNode of Task_List */
   
   }

   /* Modify an item , given the index and the module_object. 
    * Note that the index gives the position of the node in the linked list. So,
    * to modify that node, we simply traverse to that node and modify it .
    */

   public void Modify_data(int index, module_class module_object)
   {
       counter = 0;
       temp = firstNode;
       while(counter != index )
       {
        temp=temp.next_module; /* Counter to reach to index */
        counter++;
       }
       temp.data.identifier = module_object.identifier;
       temp.data.channels = module_object.channels;
       temp.data.r_rate = module_object.r_rate;
       temp.data.precedence = module_object.precedence;
       temp.data.code_pointer = module_object.code_pointer;
   }

/* remove the inter task commmunication node of a particular task in the list, given the index and
 * the object to be removed 
 */

   public void removeITC(int index, task_class task_object)
   {
       counter = 0;
       temp = firstNode;
       while(counter != index )
       {
        temp=temp.next_module;
        counter++;
       }

       /* Now delete the given task from it, after identifying
        * the to be deleted task. 
        */

        temp1 = temp.next_task;   /*Check if it is first ITC node. */
        if(temp1 != null)
         if((temp1.data.identifier.equals(task_object.identifier)) &&
          (temp1.data.flag == task_object.flag))
           {
             temp.next_task = temp1.next_task;
           }
         else
         {
          prev1 = temp1;
          while(temp1 != null)
          {
            if((temp1.data.identifier.equals(task_object.identifier)) &&
               (temp1.data.flag == task_object.flag))
               {
                 prev1.next_task = temp1.next_task;
                 break;         /* Deleted , so exit. */
               }
            else
             {
               prev1 = temp1;
               temp1 = temp1.next_task;
             }
          }
        }    /* End of else */
   }

 /* Updates the ITC information of a particulat task with a another task, given index, index in the
  * itc list, and new object to replace. 
  */

  public void update_itc(int index, int index_itc, task_class task_object)
   {
       counter = 0;
       temp = firstNode;
       while(counter != index )
       {
        temp=temp.next_module;
        counter++;
       }

  /* Now using index_itc, search for the particular task to be updated. */

       counter = 1;
       temp1 = temp.next_task;
       while(counter++ != index_itc)
        {
           temp1 = temp1.next_task;
        }
     
  /* Now the temp1 points to the task to be modified to task_object */

       temp1.data.channels = task_object.channels;
       temp1.data.identifier = task_object.identifier;
       temp1.data.amount_of_data = task_object.amount_of_data;
       temp1.data.flag = task_object.flag;
  }

 public void addnew_itc(int index,task_class task_object)
 {
       counter = 0;
       temp = firstNode;
       while(counter != index )
       {
        temp=temp.next_module;
        counter++;
       }

       /* Now goto the last task node to add this one. */

       if(temp.next_task != null)
       {
          temp1 = temp.next_task;
          while(temp1.next_task != null)
          {
             temp1 = temp1.next_task;
          }
          temp1.next_task = new Task_Node(task_object);
       }
       else
          temp.next_task = new Task_Node(task_object);
    }

  public boolean isEmpty()
    {
       return firstNode==null;
    }
  public void insert_Binding(TtoC_binding_class ttoc_object)
  {
     /* Add this binding info to corresponding module_node. 
      * Remember, one task can be bound to only one component at a time,
      * so each task will have only one binding node at any time.
      */
        temp = firstNode;
        while(temp != null)
        { 
           if(temp.data.identifier.equals(ttoc_object.task))
           {
             tempb = temp.next_binding ; /* If the first node is empty.....*/
             if(tempb == null)
               temp.next_binding = new TtoC_binding_Node(ttoc_object);
             else
             {
             /* Else, pop up an error message saying that he/she is attempting to
              * bind the same task to more than one component at a time.
              */
              /*  while(tempb.next_binding != null)
                {
                   tempb=tempb.next_binding;
                }
                tempb.next_binding = new TtoC_binding_Node(ttoc_object);*/
              System.out.println("Attempt to bind the same task to more than one component, \n ATTEMPT FAILED.");
             }
              
             break;
           }
           temp = temp.next_module;
        }
  }
}
