import java.awt.event.*;
import java.awt.*;
import java.io.*;

public class PN_MyTextHandler implements ActionListener, ItemListener
 {
      private processor_pentform pmips_form;
      private  processor_pent_primary_cache pcache;
    //  private processor_mips_secondary_cache scache;
      processor_record p_record;
      private processor_class processor_object;
      private  RandomAccessFile processor_file,load_processors;
      private File pfile,lp;
      private int position,count;

      public PN_MyTextHandler(processor_pentform  pmips_form)
      {
          this.pmips_form=pmips_form;
          p_record = new processor_record();
       
       /* Initially there are no Caches */

          p_record.setP_identifier("None");
          p_record.setPolicy("None");
          pfile = new File("processor_file");
          lp = new File("load_processors");
      }


    public void actionPerformed (ActionEvent ae)
    {
  
       String arg  = (String) ae.getActionCommand();
       if (ae.getSource() == pmips_form.Clear)
       {
        pmips_form.f0.setText("");
        pmips_form.f1.setText("");
     //   pmips_form.f2.setText("");
        pmips_form.f3.setText("");
        pmips_form.f4.setText("");
            
       }
       else if (ae.getSource() == pmips_form.Done)
       {
           p_record.setIdentifier(pmips_form.f0.getText().trim());
           p_record.setSpeed(Double.valueOf(pmips_form.f1.getText()).doubleValue());
           p_record.setMemory(pmips_form.f3.getText().trim());
       //    p_record.setMref(Double.valueOf(pmips_form.f2.getText()).doubleValue());
           p_record.setMref_Width(Double.valueOf(pmips_form.f4.getText()).doubleValue());
           processor_object = new  processor_class();
         try         
           {
             if(lp.exists()&&(lp.length()> 4))
             {
               System.out.println("Load_Processors exists");
               load_processors = new RandomAccessFile("load_processors", "rw");
               count = load_processors.readInt();
               position = load_processors.readInt(); /* This is the position in the file, where to add this record. */             
               System.out.println("The read position is" + position);
             }
             else
              {
               System.out.println("Load_processors does not exist");
               load_processors= new RandomAccessFile("load_processors", "rw");
               load_processors.writeInt(0); /* Set count to 0 */
               position = -1; /* next position to write in the memory_file will be 0 */
              }
              if(pfile.exists())
              {
                processor_file = new RandomAccessFile("processor_file", "rw");
              }
              else
              {
               System.out.println("Sorry, the library doesn't exist, \nCould not load memories");
               position = -1;
               processor_file = new RandomAccessFile("processor_file", "rw");
              }
          }
          catch (IOException e)
           {
               System.err.println("1.File not opened properly\n ");
               System.exit(1);
           }
          try
          {
            position++;
            processor_file.seek((long) (position*processor_class.object_size));
            p_record.write(processor_file);
            load_processors.seek((long) 4);    /* Re-store the incremented next position to write */
            System.out.println("The value of position "+position +"is re-stored");
            load_processors.writeInt(position);
          }
          catch (IOException e)
          {
              System.err.println("2:File not opened properly\n");
              System.exit(1);
          }

         try        
         {
           processor_file.close();
           load_processors.close();
         }
         catch(IOException e)
         {
           System.out.println("Error, could not close processor_file");
           System.exit(1);
         }
       pmips_form.setVisible(false);
       }
    
   }
   public void itemStateChanged(ItemEvent e)
   {
    if(pmips_form.Cache.getSelectedItem()=="Primary Cache")
    {
      pcache = new processor_pent_primary_cache(this);
      pcache.setVisible(true);
      pcache.setSize(600,600);
    }
/*    else if (pmips_form.Cache.getSelectedItem()=="Secondary Cache")
    {
      scache = new processor_mips_secondary_cache(this);
      scache.setVisible(true);
      scache.setSize(600,300);
    }*/
  }
}
                          
