import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class Processor_Util extends Frame implements ItemListener
 { 
    private Choice components;
    private RandomAccessFile processor_file,load_processors;
    private String processor_name_string,selected;
    private processor_record p_record;
    private compute_pu ftop;
    private Label  records;
    private File lp,pf;
    private int position,count,i,index;
    private double Mrefs[],Speeds[],Phit[],Tlinereads[],Paccess[],Twordwrites[],Tlinewrites[],Tlsizes[],Dpratios[];
    private String[] Memories,Policies;
    private Module_List m_list;
    private Ctob_binding_List ctob_list;
 
   public Processor_Util(Module_List m_list,Ctob_binding_List ctob_list)
   {
     super ("Choose a Processor to view its utilization");
     this.m_list=m_list;
     this.ctob_list=ctob_list;
     Mrefs = new double[5];
     Speeds =  new double[5];
     Memories = new String[5];
     Policies = new String[5];
     Phit = new double[5];
     Tlinereads = new double[5];
     Paccess = new double[5];
     Tlinewrites = new double[5];
     Twordwrites = new double[5];
     Tlsizes = new double[5];
     Dpratios = new double[5];
     p_record = new processor_record();
     components = new Choice();
     setLayout(new  FlowLayout());
     records = new Label("The Existing Processor Components are :");
     setBackground(Color.lightGray);
     setForeground(Color.black);
     Font f = new Font("Serif",Font.PLAIN+Font.BOLD,15);
     setFont(f);
     lp = new File("load_processors");
     pf = new File("processor_file");
   if(lp.exists())  /* If this does not exist, we can't load anything */
   {
     try
           {
            if(pf.exists()&&(pf.length()!=0))
            {
               processor_file = new RandomAccessFile("processor_file","rw");
            }
            else
            {
              processor_file = new RandomAccessFile("processor_file","rw");
              count=0;
              position = -1;
            }
            load_processors = new RandomAccessFile("load_processors","rw");
            count = load_processors.readInt();   
            position = load_processors.readInt();
           }
                   
     catch(IOException e)
         {
              System.err.println("From Del_C, File could not be opened ");
              setVisible(false);
         }
        i=0;              
        for(int k=count;k<=position;k++)
        {
          try
          {
             processor_file.seek( (long) k*(processor_class.object_size));
             p_record.read(processor_file); 
             processor_name_string  = p_record.getIdentifier();
             if(processor_name_string.startsWith("Delet"))
             continue;
             components.add(processor_name_string.trim());
             Mrefs[i]=p_record.getMref_Width();
             Speeds[i]=p_record.getSpeed();
             Phit[i]=p_record.getP_hit_ratio();
             Tlinereads[i]=p_record.getTlread();
             Paccess[i]=p_record.getP_access_time();
             Policies[i]=p_record.getPolicy();
             Tlinewrites[i]=p_record.getTlwrite();
             Twordwrites[i]=p_record.getTw_write();
             Tlsizes[i]= p_record.getTlsize();
             Dpratios[i]= p_record.getDpratio();
             Memories[i++]=p_record.getMemory();

          }
          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }
       }
   }
 
   components.addItemListener(this);
   add(records);
   add(components);
   DelCP_MyWindowAdapter adapter = new DelCP_MyWindowAdapter(this);
   addWindowListener(adapter);
  }

 public void itemStateChanged(ItemEvent e)
   {
      String selected  = (components.getSelectedItem()).trim();
      index = components.getSelectedIndex();

      ftop = new compute_pu(m_list,ctob_list,selected,Speeds[index],Mrefs[index],Memories[index],Phit[index],Paccess[index],Tlinereads[index],Twordwrites[index],Tlinewrites[index],Tlsizes[index],Policies[index],Dpratios[index]);
      setVisible(false);
   }
}
