import java.awt.*;
import java.io.*;
import java.awt.event.*;

public class compute_bu 
{

  private Module_List m_list;
  private Ctob_binding_List ctob_list;
  private String[] components,task_names;
  private double[] ports;
  private double[] amounts,r_rates,result; 
  private  draw_pie dp;
  private int i,j,k,m,c,r,count,position;
  private Module_Node fmnode;
  private Ctob_binding_Node fbnode;
  private TtoC_binding_Node bnode;
  private Task_Node temp1;
  private int[] channels;
  private double tlsize,mrefw,dpratio,phit,xx;
  private RandomAccessFile processor_file,load_processors;
  private File lp,pf;
  private processor_record p_record;
  private String processor_name_string;
 

  public compute_bu(Module_List m_list,Ctob_binding_List ctob_list,String selected_bus,double bwidth)

 {
  
    this.m_list=m_list;
    this.ctob_list=ctob_list;
    components = new String[20];
    task_names = new String[20];
    amounts = new double[20];
    r_rates = new double[20];
    result = new double[20];
    ports = new double[10];
    channels= new int[10];
    p_record = new processor_record();

/* Search the binding list and collect all the components and
 * their ports connected to the selected bus.
 */

    fbnode = ctob_list.firstNode;
    i=0;
    while(fbnode != null)
    {

      if(fbnode.data.bus_identifier.equals(selected_bus.trim()))
      {
         components[i]=fbnode.data.ip_identifier.trim();
         ports[i++] = fbnode.data.port;
      }
         fbnode = fbnode.next_node;
         
    }

    /* Open the processor file for getting their characteristics like
     * hit ratios and line sizes etc.
     */ 


     lp = new File("load_processors");
     pf = new File("processor_file");
   if(lp.exists())  /* If this does not exist, we can't load anything */
   {
     try
           {
            if(pf.exists()&&(pf.length()!=0))
            {
               processor_file = new RandomAccessFile("processor_file","rw");
            }
            else
            {
              processor_file = new RandomAccessFile("processor_file","rw");
              count=0;
              position = -1;
            }
            load_processors = new RandomAccessFile("load_processors","rw");
            count = load_processors.readInt();
            position = load_processors.readInt();
           }

     catch(IOException e)
         {
              System.err.println("From Del_C, File could not be opened ");
         }
    }

    /* Now go through the m_list to find out the tasks which are 
     * mapped to the right ports of one of the above components. 
     */

    fmnode = m_list.firstNode; 
    k=0;
    while(fmnode != null)
    {
        bnode=fmnode.next_binding;
        for(j=0;j<i;j++) /* There are i-1 components added to this bus */
        {
           c=0; 
           if(bnode.data.component.equals(components[j]))
            {
                for(m=1;m<=bnode.data.ports[0];m++)/* bnode.data.ports[0] will be zero for a processor.*/
                {
                  if(ports[j]==bnode.data.ports[m])
                    channels[c++]=bnode.data.channels[m];
                }      
                /* Find, through this channel, with which tasks this task is communicating. */
                temp1 = fmnode.next_task;
                while(temp1 != null)
                {
                   if(c==0)  
                    {
                       amounts[k] += temp1.data.amount_of_data;
                       temp1=temp1.next_task;
                    }
                             /* That is, it is a processor, so take all the itc and add, without
                              * matching for channels to ports, as all the channels
                              * are mapped to the same port of the processor, i.e., 0
                              */
                   else 
                   {
                     for(m=0;m<c;m++)
                       if(temp1.data.channels==channels[m])
                          amounts[k] += temp1.data.amount_of_data;
                     temp1=temp1.next_task;
                   }
                }
                /* Now search for this processor and get its chracteristics
                 * for calculating the code transfer bytes
                 */
                 
        for(int r=count;r<=position;r++)
        {
          try
          {
             processor_file.seek( (long) r*(processor_class.object_size));
             p_record.read(processor_file);
             processor_name_string  = p_record.getIdentifier();
             if(processor_name_string.startsWith("Delet"))
             continue;

             if(processor_name_string.trim().equals(bnode.data.component))
             {
                      mrefw=p_record.getMref_Width();
                      phit=p_record.getP_hit_ratio();
                      tlsize= p_record.getTlsize();
                      dpratio= p_record.getDpratio();
               if(phit != 0)  /* That means Cache is existing */
               {
                  if(p_record.getPolicy().trim().startsWith("WT"))
                  {
                     
                      amounts[k] += (bnode.data.l_inst+bnode.data.d_inst)*(1-phit/100)*tlsize+(bnode.data.s_inst*mrefw);
                      break;
                  }
                  else if(p_record.getPolicy().trim().startsWith("CB"))
                  {
                    xx=(bnode.data.l_inst+bnode.data.s_inst+bnode.data.d_inst);
                    amounts[k] += xx*(1-phit/100)*tlsize*(1.0 + dpratio);
                      break;
                  }
               }
               else /* There is no cache */
               {
                 amounts[k] += (bnode.data.l_inst+bnode.data.s_inst+bnode.data.d_inst)*mrefw; 
                 break;
               }
                    
          } /* End of "processor_name" if */
        }
          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }
       }  /* End of outer for loop */

                r_rates[k]= fmnode.data.r_rate;
                task_names[k++]=bnode.data.task;
            } /* End of outermost if */
        }

        fmnode=fmnode.next_module;
   }

    
/* Now having got everything, calculate bus utilization */


    for(i=0;i<k;i++)
    {
        result[i] = amounts[i]*1000/r_rates[i];
    }
    result[i]=bwidth;    
    dp = new draw_pie("Bus Utilization of "+ selected_bus,task_names,result,i);
    dp.setSize(1000,530);
    dp.setVisible(true);

  }
} 
