import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class compute_pu
 { 
    
    private RandomAccessFile processor_file,ip_file;
    private RandomAccessFile load_processors,memory_file,load_memories;
    private RandomAccessFile load_buses,bus_file;
    private String processor_name_string,memory_name_string,memory,bus_name_string;
    private processor_record p_record;
    private bus_record b_record;
    private ip_record ip_record;
    private memory_record m_record;
    private String[] task_names,itc_components,itc_names;
    private double[] result,itc_bwidths,I_counts,S_counts,itc_bytes,mem_delays;
    private double[] comm_times,r_rates,compute_times;
    private double sum,dmabus_width,access_time;
    private int[] itc_modes,itc_start;
    private File lp,pf,lm,mf,lb,bf;
    private int position,count,i,p_len,first_pos,last_pos,j,k,no_of_tasks;
    private Module_List m_list;
    private Module_Node fnode,fnode1;
    private Task_Node task_node,task_node1;
    private Ctob_binding_Node ctob_node;
    private TtoC_binding_Node bnode,bnode1;
    private Ctob_binding_List ctob_list;
    private draw_pie dp;
    private String  data,temp_component;
    private boolean duplicate;
     
public compute_pu(Module_List m_list,Ctob_binding_List ctob_list,String selected_processor,double speed,double mref_width,String memory_connection,double phit,double pa_time,double tlread,double tw_write,double tlwrite,double tlsize,String policies,double dpratio)
	   {
	    
	     p_record = new processor_record();
	     m_record = new memory_record();
             ip_record = new ip_record();
             b_record = new bus_record();

          /* Initialize the arrays .*/

             task_names = new String[10];
             itc_components = new String[20];
             result = new double[10];
             itc_bytes= new double[20];
             itc_bwidths= new double[20];
             itc_modes = new int[20];
             mem_delays = new double[10];
             comm_times = new double[10];
             compute_times = new double[10];
             itc_names = new String[20];
             I_counts = new double[20];
             S_counts = new double[20];
             r_rates = new double[10];
             itc_start = new int[10];

	     this.m_list = m_list;
             this.ctob_list = ctob_list;
	     System.gc();     /* Explicit call to Garbage Collector */

          /* Get the access time of the memory to which this processor
           * is connected.
           */

             lm = new File("load_memories");
             mf = new File("memory_file");
   if(lm.exists())  /* If this does not exist, we can't load anything */
   {
     try
        {
            if(mf.exists()&&(mf.length()!=0))
            {
               memory_file = new RandomAccessFile("memory_file","rw");
            }
            else
            {
              memory_file = new RandomAccessFile("memory_file","rw");
              count=0;
              position = -1;
            }
            load_memories = new RandomAccessFile("load_memories","rw");
            count = load_memories.readInt();   
            position = load_memories.readInt();
        }
                   
     catch(IOException e)
        {
              System.err.println("From Del_C, File could not be opened ");
        }
     for(int k=count;k<=position;k++)
        {
          try
          {
             memory_file.seek( (long) k*(memory_class.object_size));
             m_record.read(memory_file); 
             memory_name_string  = m_record.getIdentifier();
             if(memory_name_string.startsWith("Deleted"))
             continue;
             else if(memory_name_string.trim().equals(memory_connection.trim()))
            {
             access_time = m_record.getAccess_time();
            }
          }
          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }
       }   
    }/* end of if */

                         
           /* Check for the tasks bound to the processors in the array
	    * "processors".
	    */
                                                  
	    i=0;
            j=0;
            data= selected_processor;
	    fnode = m_list.firstNode;
            System.gc();
	    while(fnode != null)
	    {
             duplicate = false;
	     bnode = fnode.next_binding;
                           
             if(data.trim().equals(bnode.data.component.trim()))
		     {
                         task_names[i] = bnode.data.task;
                         itc_start[i]=j;
                         I_counts[i]=bnode.data.l_inst+bnode.data.d_inst;
                         S_counts[i++]=bnode.data.s_inst;
                         task_node = fnode.next_task;
                         while(task_node != null)
                         {
                             itc_bytes[j]=task_node.data.amount_of_data;
                             r_rates[j]= fnode.data.r_rate;
                             ctob_node = ctob_list.firstNode;
                             while(ctob_node != null)
                             {
                                if (data.trim().equals(ctob_node.data.ip_identifier))
                                 {
                                    itc_bwidths[j++]=ctob_node.data.Bwidth;
                                    break;
                                 }
                                ctob_node=ctob_node.next_node;
                             }
                             task_node = task_node.next_task;                        
                         }


/*                       //  itc_components[j]=bnode.data.component.trim();  
                         task_node = fnode.next_task;
                         while(task_node != null)
                         { 
                            itc_bytes[j]=task_node1.data.amount_of_data;
                            r_rates[j]= fnode1.data.r_rate;
                            
                    //       itc_names[j]=task_node.data.identifier.trim();
                    //       itc_bwidths[j]=0;*/

     /* For this particular itc entry find the binding.  */
                          fnode1=m_list.firstNode;
                          while(fnode1 != null)
                          {
                            task_node1=fnode1.next_task;
                            while(task_node1 != null)
                            {
                               if(task_node1.data.identifier.trim().equals(task_names[i-1].trim()))
                               {

           /* We found a task which is sending some data to this task. So
            * note down the amount of data as well as the bandwidth of the 
            * bus to which it is connected and the repetition rate of that task .
            */
                                  itc_bytes[j]=task_node1.data.amount_of_data;
                                  r_rates[j]= fnode1.data.r_rate;
                                  bnode1=fnode1.next_binding;
                                  temp_component=bnode1.data.component.trim();

           /* Using the above temp_component variable, we find the bandwidth of the bus  
            * to which the task, which is communicating with task_names[i] is bound .
            */
                                  ctob_node = ctob_list.firstNode;
                                  while(ctob_node != null)
                                  {
                                     if(ctob_node.data.ip_identifier.trim().equals(temp_component))
                                     {
                                        itc_bwidths[j++]=ctob_node.data.Bwidth;
                                        break;
                                     }
                                     ctob_node = ctob_node.next_node;
                                  }
                                  break;
                               }
                               task_node1=task_node1.next_task;
                            } /* Second while */
                            fnode1=fnode1.next_module;
                         }

                    } /* End of outer if */
                    fnode=fnode.next_module;
                } /* End of outer most while */    
             itc_start[i]=j;        
                                    
                   /*       while(fnode1 != null)
                          {
                            if(fnode1.data.identifier.trim().equals(itc_names[j]))
                           {
                             bnode1 = fnode1.next_binding;
                             itc_components[j]=bnode1.data.component.trim();
                             break;
                           }
                            fnode1 = fnode1.next_module;
                          }
                           itc_bytes[j]=task_node.data.amount_of_data;
                           task_node=task_node.next_task;
                         }
                     }*/
        /*     itc_start[i]=j;  / For the purpose knowing the end of last itc       
             fnode = fnode.next_module;
	    }*/

            /* Now find out the bus through which each of the ITC fields
             * Communicate .
             */
              
             no_of_tasks = i;
      /* System.out.println("The number of tasks added & j is "+ no_of_tasks+","+j);
          
             
             for(k=0;k<j;k++)
             {
                ctob_node=ctob_list.firstNode;
             while(ctob_node != null)
             {
               if(ctob_node.data.ip_identifier.equals(itc_components[k]))
               {
                  itc_bwidths[k]=ctob_node.data.Bwidth;
                  break;
               }            
               ctob_node = ctob_node.next_node;
             }
            }*/

              /* j represents the final bound on itc array 
              */

               
            /*Now ,having got everything, calculate the total execution time. */
            /*first calculate computation time of each task. */
            i=0;
            for(i=0;i<no_of_tasks;i++)
            {
              compute_times[i]=(I_counts[i]+S_counts[i])/(speed*1000000);/* Speed in MIPS */

               if(phit != 0) /* That is Cache is existing */
               {
                  if(policies.startsWith("WT"))
                   {

                     mem_delays[i]=((S_counts[i]*access_time) + (I_counts[i]*pa_time*phit/100) + (1-phit/100)*I_counts[i]*tlread)/1000000000;     
                   }
                  if(policies.startsWith("CB"))
                   {

                     mem_delays[i]=((S_counts[i]+I_counts[i]*phit/100*pa_time) + ((1-phit/100)*((I_counts[i]+S_counts[i])*tlread))+(dpratio*tlwrite*(I_counts[i]+S_counts[i])))/1000000000;     
                   }

               }
               else  /* No cache exists */
               {
                mem_delays[i]= (I_counts[i]+S_counts[i])*access_time/1000000000;     
               }

                 /*  access time in ns is converted to sec ,
                  *  the paranthesis has effective access time of the memory system.
                  */

        System.out.println("The compute and mem_delays are "+ compute_times[i]+", "+mem_delays[i]);
              first_pos = itc_start[i];
              last_pos = itc_start[i+1];
              sum=0;
              for(k=first_pos;k<last_pos;k++)
              {
               sum += 1000/r_rates[k]*itc_bytes[k]/(itc_bwidths[k]*1024);/* Transfer Bytes are in KB. */
              } 
              comm_times[i]=sum;
        System.out.println("The comm time is "+sum);
            }

    /* Now , having got the execution times of all the tasks bound to the
     * selected processor, compute values in result array to be sent to
     * draw_pie class. For this periodicity of each task is required.
     */

/*   for(k=0;k<no_of_tasks;k++)
   {
      fnode = m_list.firstNode;
      while(fnode!=null)
      {
          if(fnode.data.identifier.trim().equals(task_names[k]))
          {
             periodicities[k]=fnode.data.r_rate;
          break;
          }
          else
          fnode=fnode.next_module;
      }
   }*/
   System.gc();
   for(i=0;i<no_of_tasks;i++)
   {
     result[i]=comm_times[i]+(mem_delays[i]+compute_times[i])*1000/r_rates[itc_start[i]];  /* For comm times are already multiplied with r_rates. */
     System.out.println("The i and result[i] is"+i+" ,"+result[i]);
   }
   result[no_of_tasks]=1.0; /* As we have calculated the utilization for 1 second of time. */
   dp =new draw_pie("The Processor Utilization of "+selected_processor,task_names,result,no_of_tasks);
   dp.setSize(1000,530);
   dp.setVisible(true);
   
 }

}      
