import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class compute_space
 { 
    
    private RandomAccessFile processor_file,ip_file;
    private RandomAccessFile load_processors,memory_file,load_memories,load_ips;
    private String processor_name_string,memory_name_string,memory,ip_name_string;
    private processor_record p_record;
    private ip_record ip_record;
    private memory_record m_record;
    private String[] util_name,processors;
    private double[] util_space;
    private File lp,pf,lm,mf,lip,ipf;
    private int position,count,i,p_len;
    private Module_List m_list;
    private Module_Node fnode;
    private TtoC_binding_Node bnode;
    private draw_pie dp;
    String  data;
    boolean duplicate;
					     
    public compute_space(Module_List m_list,String selected_memory)
	   {
	    
	     p_record = new processor_record();
	     m_record = new memory_record();
             ip_record = new ip_record();
	     processors = new String[10];
	     util_name = new String[20];
	     util_space = new double[20];
	     this.m_list = m_list;
	     System.gc();     /* Explicit call to Garbage Collector */
	     lp = new File("load_processors");
	     pf = new File("processor_file");

	   if(lp.exists())  /* If this does not exist, we can't load anything */
	   {
	       
	     try
		   {
		    if(pf.exists()&&(pf.length()!=0))
		    {
		     
		       processor_file = new RandomAccessFile("processor_file","rw");
		    }
		    else
		    {
		      processor_file = new RandomAccessFile("processor_file","rw");
		      count=0;
		      position = -1;
		    }
		    load_processors = new RandomAccessFile("load_processors","rw");
		    count = load_processors.readInt();   
		    position = load_processors.readInt();
                   }                                                                
			   
	     catch(IOException e)
		 {
		      System.err.println("From Del_C, File could not be opened ");
                   
		 }
		i=0;
	     
		for(int k=count;k<=position;k++)
		{
		  try
		  {
		     processor_file.seek( (long) k*(processor_class.object_size));
		     p_record.read(processor_file); 
		     processor_name_string  = p_record.getIdentifier();
                     if(processor_name_string.startsWith("Delet"))               
		       continue;
		     memory = p_record.getMemory();
                    
                     if(memory.trim().equals(selected_memory))

		      {
                        processors[i++] = processor_name_string;
		      }

		  }
		  catch(IOException e)
		  {
		      System.err.println("File could not be read ");
		      System.exit(1);
		  }
	       }
	   }

/* As IPs are assumed to have local memory, they are not considered
 * in calculating memory space utilization.
 */
     
     
/*     lip = new File("load_ips");
     ipf = new File("ip_file");
   if(lip.exists())  / If this does not exist, we can't load anything /
   {
     try
        {
            if(ipf.exists()&&(ipf.length()!=0))
            {
               ip_file = new RandomAccessFile("ip_file","rw");
            }
            else
            {
              ip_file = new RandomAccessFile("ip_file","rw");
              count=0;
              position = -1;
            }
            load_ips = new RandomAccessFile("load_ips","rw");
            count = load_ips.readInt();   
            position = load_ips.readInt();
           
        }
                   
     catch(IOException e)
        {
              System.err.println("From Del_C, File could not be opened ");
             
        }
//        temp_var = i;  
     for(int k=count;k<=position;k++)
       {
          try
          {
             ip_file.seek( (long) k*(ip_class.object_size));
             ip_record.read(ip_file); 
             ip_name_string  = ip_record.getIdentifier();
             if(ip_name_string.startsWith("Deleted"))
             continue;
             if(selected_memory.equals("DRAM"))
             processors[i++] = ip_name_string;
           
          }             
          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }

       }
 }                                */
 
            /* Check for the tasks bound to the processors in the array
	    * "processors".
	    */
	    p_len = i;
            System.out.println("Check point two");
                                      
	    i=0;
	    fnode = m_list.firstNode;
	    while(fnode != null)
	    {
             duplicate = false;
	     bnode = fnode.next_binding;
                  for (int j=0;j<p_len;j++)
		   {
                     System.gc();
                     data = processors[j];
                     System.out.println("The processor taken up is "+data);
                     if(data.trim().equals(bnode.data.component.trim()))
		     {
                      
                          for(int k=0;k<i;k++)
                              {
                                    if (util_name[k].equals(bnode.data.task))
                                      {
                                           duplicate = true;
                                      }  
                              }
                          if(duplicate!= true)
                             {
                                util_name[i] = bnode.data.task+" on "+bnode.data.component+" Code Size";
                                util_space[i++]=bnode.data.c_size;                     
                                util_name[i] = bnode.data.task+" on "+bnode.data.component+ " Data Size";
                                util_space[i++]=bnode.data.d_size;
                                util_name[i] = bnode.data.task+" on "+bnode.data.component+ " Stack Size";
                                util_space[i++]=bnode.data.s_size;

                                break;
                             }
                     }
                   }
	       fnode = fnode.next_module;
              }       
           
	    /* Add the memory size at last */

	     lm = new File("load_memories");
	     mf = new File("memory_file");
	  if(lm.exists())  /* If this does not exist, we can't load anything */
   {
     try
        {
            if(mf.exists()&&(mf.length()!=0))
            {
               memory_file = new RandomAccessFile("memory_file","rw");
            }
            else
            {
              memory_file = new RandomAccessFile("memory_file","rw");
              count=0;
              position = -1;
            }
            load_memories = new RandomAccessFile("load_memories","rw");
            count = load_memories.readInt();   
            position = load_memories.readInt();
        }                                                                       
     catch(IOException e)
        {
              System.err.println("From Del_C, File could not be opened ");
         
        }
                    
     for(int k=count;k<=position;k++)
        {
          try
          {
             memory_file.seek( (long) k*(memory_class.object_size));
             m_record.read(memory_file); 
             memory_name_string  = m_record.getIdentifier();
             if(memory_name_string.startsWith("Deleted"))
             continue;
             else if (memory_name_string.trim().equals(selected_memory))
              {
                 util_space[i]=m_record.getSize();
                 break;                                                                         
              }
          }
          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }
       }   
    }/* end of if */
     
   dp =new draw_pie("The Memory Space Utilization of"+" "+selected_memory,util_name,util_space,i);
   dp.setSize(1000,530);
   dp.setVisible(true);
   
 }

}      


