import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class compute_vu extends Canvas implements ItemListener
 { 
    private Choice components;
    private RandomAccessFile processor_file,load_processors,load_memories,memory_file;
    private RandomAccessFile bus_file,load_buses,ip_file,load_ips;
    private String processor_name_string,memory_name_string,ip_name_string,bus_name_string;
    private processor_record p_record;
    private bus_record b_record;
    private memory_record m_record;
    private ip_record ip_record;
    private file_to_processor_form ftop;
    private Label  records;
    private File lp,pf,bf,lb,ipf,lip,mf,lm;
    private int position,count,count_tm,count_mips;
    private Module_List m_list;
    private Ctob_binding_List ctob_list;
    private int[] x,y;
 
   public compute_vu(Module_List m_list, Ctob_binding_List ctob_list)
   {
     this.m_list = m_list;
     this.ctob_list=ctob_list;
   }
   public void paint(Graphics g)
   {
   /* Open all the files and add the components to the screen.  */

     p_record = new processor_record();
     b_record = new bus_record();
     m_record = new memory_record();
     ip_record = new ip_record();
     count_mips = 0;
     count_tm =0;
     x = new int[5];   /* Used to draw pointed edge at the end of buses. */
     y = new int[5];
     lp = new File("load_processors");
     pf = new File("processor_file");
   if(lp.exists())  /* If this does not exist, we can't load anything */
   {
     try
           {
            if(pf.exists()&&(pf.length()!=0))
            {
               processor_file = new RandomAccessFile("processor_file","rw");
            }
            else
            {
              processor_file = new RandomAccessFile("processor_file","rw");
              count=0;
              position = -1;
            }
            load_processors = new RandomAccessFile("load_processors","rw");
            count = load_processors.readInt();   
            position = load_processors.readInt();
            System.out.println("The count value & position read are "+count+", " + position);
           }
                   
     catch(IOException e)
         {
              System.err.println("From Del_C, File could not be opened ");
         
         }
                      
        for(int k=count;k<=position;k++)
        {
          try
          {
             processor_file.seek( (long) k*(processor_class.object_size));
             p_record.read(processor_file); 
             processor_name_string  = p_record.getIdentifier();
             if(processor_name_string.startsWith("Delet"))
             continue;
             if(processor_name_string.trim().startsWith("MIPS"))
             {
                g.setColor(Color.green);
                g.fill3DRect(250-count_mips*120,50,100,100,true);
                g.setColor(Color.red);
                g.drawString(processor_name_string.trim(),255-count_mips*120,100);
                count_mips++;
             }
            else if(processor_name_string.trim().startsWith("TM"))
             {
                g.setColor(Color.green);
                g.fill3DRect(550+count_tm*120,50,100,100,true);
                g.setColor(Color.red);
                g.drawString(processor_name_string.trim(),555+count_tm*120,100);
                count_tm++;
             }
                         
           }
          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }
       }
   }
     lb = new File("load_buses");
     bf = new File("bus_file");
   if(lb.exists())  /* If this does not exist, we can't load anything. */
   {
     System.out.println("Lb exists");
     try
      {
            if(bf.exists()&&(bf.length()!=0))
            {
               bus_file = new RandomAccessFile("bus_file","rw");
            }
            else
            {
              bus_file = new RandomAccessFile("bus_file","rw");
              System.out.println("not exists and bf is opened");
              count=0;
              position = -1;
            }
       }
     catch(IOException e)
         {
              System.err.println("From Del_C, File could not be opened. ");
         }        
     try
      {
            load_buses = new RandomAccessFile("load_buses","rw");
            count = load_buses.readInt();   
            position = load_buses.readInt();
            System.out.println("The count value & position read are "+count+", " + position);
       
      }
                   
     catch(IOException e)
         {
              System.err.println("load_buses File could not be opened. ");
         }
              
     for(int k=count;k<=position;k++)
        {
          try
          {
             bus_file.seek( (long) k*(bus_class.object_size));
             b_record.read(bus_file); 
             bus_name_string  = b_record.getIdentifier();
             if(bus_name_string.startsWith("Deleted"))
             continue;
             if(bus_name_string.trim().startsWith("HB DMA"))
             {
               g.setColor(Color.yellow);     /* Between MIF and DRAM. */
               g.fill3DRect(435,135,30,5,true);
               x[0]=435;x[1]=425;x[2]=450;x[3]=475;x[4]=470;
               y[0]=135;y[1]=135;y[2]=125;y[3]=135;y[4]=135;
               g.fillPolygon(x,y,x.length);
               x[0]=435;x[1]=428;x[2]=450;x[3]=473;x[4]=470;
               y[0]=139;y[1]=139;y[2]=150;y[3]=139;y[4]=139;
               g.fillPolygon(x,y,x.length);

               g.fillPolygon(x,y,x.length);
               g.fill3DRect(435,235,30,400,true);
               x[0]=435;x[1]=425;x[2]=450;x[3]=475;x[4]=470;
               y[0]=235;y[1]=235;y[2]=210;y[3]=235;y[4]=235;
               g.fillPolygon(x,y,x.length);
               x[0]=435;x[1]=425;x[2]=450;x[3]=475;x[4]=470;
               y[0]=633;y[1]=633;y[2]=660;y[3]=633;y[4]=633;
               g.fillPolygon(x,y,x.length);
               g.setColor(Color.red);
               g.drawString("H",443,280);
               g.drawString("B",443,320);
               g.drawString("D",443,390);
               g.drawString("M",443,430);
               g.drawString("A",443,470);
               g.drawString("B",443,540);
               g.drawString("U",443,580);
               g.drawString("S",443,620);

             }
        }

          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }
       }   
    }/* end of if */
     lip = new File("load_ips");
     ipf = new File("ip_file");
   if(lip.exists())  /* If this does not exist, we can't load anything */
   {
     try
        {
            if(ipf.exists()&&(ipf.length()!=0))
            {
               ip_file = new RandomAccessFile("ip_file","rw");
            }
            else
            {
              ip_file = new RandomAccessFile("ip_file","rw");
              count=0;
              position = -1;
            }
            load_ips = new RandomAccessFile("load_ips","rw");
            count = load_ips.readInt();   
            position = load_ips.readInt();
            System.out.println("The count value & position read are "+count+", " + position);
        }
                   
     catch(IOException e)
        {
              System.err.println("From Del_C, File could not be opened ");
        }   
              
     for(int k=count;k<=position;k++)
        {
          try
          {
             ip_file.seek( (long) k*(ip_class.object_size));
             ip_record.read(ip_file); 
             ip_name_string  = ip_record.getIdentifier();
             if(ip_name_string.startsWith("Deleted"))
             continue;
           }
          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }
       }   
    }/* end of if */
    
     lm = new File("load_memories");
     mf = new File("memory_file");
   if(lm.exists())  /* If this does not exist, we can't load anything */
   {
     try
        {
            if(mf.exists()&&(mf.length()!=0))
            {
               memory_file = new RandomAccessFile("memory_file","rw");
            }
            else
            {
              memory_file = new RandomAccessFile("memory_file","rw");
              count=0;
              position = -1;
            }
            load_memories = new RandomAccessFile("load_memories","rw");
            count = load_memories.readInt();   
            position = load_memories.readInt();
            System.out.println("The count value & position read are "+count+", " + position);
        }
                   
     catch(IOException e)
        {
              System.err.println("From Del_C, File could not be opened ");
              setVisible(false);
        }
              
     for(int k=count;k<=position;k++)
        {
          try
          {
             memory_file.seek( (long) k*(memory_class.object_size));
             m_record.read(memory_file); 
             memory_name_string  = m_record.getIdentifier();
             if(memory_name_string.startsWith("Deleted"))
             continue;
             g.setColor(Color.blue);
             g.fill3DRect(400,25,100,100,true);
             g.setColor(Color.red);
             g.drawString(memory_name_string.trim(),415,75);

             /* Presently assume only one memory.
              */
             g.setColor(Color.blue);
             g.fill3DRect(419,150,60,60,true);
             g.setColor(Color.red);
             g.drawString("M.I/F",431,180);
           }
          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }
       }   
    }/* end of if */

  }                      

 public void itemStateChanged(ItemEvent e)
   { /*
      String to_be_deleted  = (components.getSelectedItem()).trim();
      System.out.println("The item selected is "+ to_be_deleted);
      ftop = new file_to_processor_form ("Delete Processor Item",to_be_deleted,processor_file,count,position);
      ftop.setVisible(true);
      ftop.setSize(600,500);
      setVisible(false);*/
   }
}
