/* This file , given the object of type processor_class stores the object in the file "processor_file",
 * loads the information about processors from the same file etc. Similar is the case with *_record files. It
 * provides the facilities to retrieve informatipon about a particular processors in the form of methods like
 * set* and get *.
 */


import java.io.*;
import java.awt.event.*;
import java.awt.*;

public class processor_record
{
    private String identifier;
    private double speed;
    private String memory;
    private double mref_width;
    private String p_identifier = "Null";
    private String policy = "Null";
    private double p_size;
    private double Tlread,Tlsize;
    private double phit_ratio;
    private double Tlwrite;
    private double Tw_write;
    private double pa_time,Dpratio;
    private MenuFrame mf;

public void write(RandomAccessFile processor_file) throws IOException

 {
    StringBuffer  buf1,buf2,buf3,buf4;
    buf1 = new StringBuffer(identifier);
    buf1.setLength(15);
    buf4 = new StringBuffer(memory);
    buf4.setLength(15);
    buf2 = new StringBuffer(p_identifier);
    buf2.setLength(15);
    buf3 = new StringBuffer(policy);
    buf3.setLength(15);
    processor_file.writeChars(buf1.toString());
    processor_file.writeDouble(speed);
    processor_file.writeChars(buf4.toString());
    processor_file.writeDouble(mref_width);
    processor_file.writeChars(buf2.toString());
    processor_file.writeDouble(p_size);
    processor_file.writeDouble(phit_ratio);
    processor_file.writeDouble(pa_time);
    processor_file.writeDouble(Tlread);
    processor_file.writeChars(buf3.toString());
    processor_file.writeDouble(Tlsize);
    processor_file.writeDouble(Tw_write);
    processor_file.writeDouble(Tlwrite);
    processor_file.writeDouble(Dpratio);
 }
    
public void read(RandomAccessFile processor_file) throws IOException
 {
   char name1[] = new char[15];
   char name4[] = new char[15];
   char name2[] = new char[15];
   char name3[] = new char[15];
   for( int i=0; i<15;i++)
   {
     name1[i] = processor_file.readChar();
   } 
   identifier = new String(name1);
   speed = processor_file.readDouble();
   for( int i=0; i<15;i++)
   {
     name4[i] = processor_file.readChar();
   }
   memory = new String(name4);
//   mref  = processor_file.readDouble();
   mref_width  = processor_file.readDouble();
   for( int i=0; i<15;i++)
   {
     name2[i] = processor_file.readChar();
   }
   p_identifier = new String(name2);
   p_size = processor_file.readDouble();
   phit_ratio  = processor_file.readDouble();
   pa_time  = processor_file.readDouble();
   Tlread = processor_file.readDouble();
   for( int i=0; i<15;i++)
   {
     name3[i] = processor_file.readChar();
   }
   policy = new String(name3);
   Tlsize = processor_file.readDouble();
   Tw_write = processor_file.readDouble();
   Tlwrite = processor_file.readDouble();
   Dpratio = processor_file.readDouble();
 }


 /*  Store Functions  for a processor object */


 public void setIdentifier(String x) { identifier = x;}
 public void setSpeed (double x) { speed = x;}
 public void setMemory(String x) { memory = x;}
 public void setMref_Width(double  x) { mref_width = x;}
 public void setP_identifier(String x) { p_identifier = x;}
 public void setP_size (double x) { p_size = x;}
 public void setP_hit_ratio(double  x) {phit_ratio = x;}
 public void setP_access_time(double x){pa_time=x;}
 public void setTlread(double x){Tlread=x;}
 public void setPolicy(String x) {policy = x;}
 public void setTlsize (double x) { Tlsize = x;}
 public void setTw_write(double  x) {Tw_write = x;}
 public void setTlwrite(double x){Tlwrite=x;}
 public void setDpratio(double x){Dpratio=x;}

 /*  Load  Functions  for a processor object */

 public String getIdentifier() { return(identifier);}
 public double getSpeed () { return(speed);}
 public String getMemory() { return (memory);}
 public double getMref_Width() { return mref_width;}
 public String getP_identifier() { return(p_identifier);}
 public double getP_size () { return(p_size);}
 public double getP_hit_ratio() {return(phit_ratio);}
 public double getP_access_time(){return(pa_time);}
 public double getTlread(){return Tlread;}
 public String getPolicy() {return policy ;}
 public double getTlsize () { return Tlsize;}
 public double getTw_write() {return Tw_write ;}
 public double getTlwrite(){return Tlwrite;}
 public double getDpratio(){return Dpratio;}
}
